# Plugin Payvalid Integration for Magento 2 multi store(2.x)

This plugin allows you to integrate Payválida as a means of payment for your different stores in Magento 2.

**If you have any questions or problems, do not hesitate to contact our technical support**

## Version 1.5.3
[Plugin Payvalid for Magento 2 multistore, Additional fields are added for checkout](https://payvalida.com/desarrolladores/plugins/magento/Payvalida_Magento-latest.zip)

In these instructions you will find instructions to install the module and activate it in your Magento 2 installation.

### Prerequisites

You need to have Magento 2 installed with all its dependencies and a Payválida account.


### Installing


1- Clone the repository on your machine and place it in the app/code folder

3- Go to the installation path of your magento 2 and run the following commands
```
php bin/magento module:enable Payvalida_Bnpl
php bin/magento setup:upgrade
php bin/magento setup:di:compile
```
4- If you want you can execute the following command to verify that the module is enabled
```
php bin/magento module:status
```

## Ending

You can now enter the Magento2 administration area and go to Stores->settings->Sales->Payment methods
and you will find the plugin panel to configure it.



